﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Connect4
{
    public static class Engine
    {
        public static char[,] board;
        public static int turn = 1;
        public static PlayersType gameType;

        public static bool CheckWinState(Player player, int line, int column)
        {
            char color = 'n';
            if (player.IsRed)
            {
                color = 'r';
            }
            else
            {
                color = 'y';
            }

            return CheckWinState(color, line, column, board);
        }

        public static bool CheckWinState(char p_Color, int line, int column, char[,] p_Board)
        {
            int TokensInLine = 1;
            bool stop = false;

            //Vérification horizontale à gauche
            for (int i = column - 1; i >= 0 && !stop; i--)
            {
                if (p_Board[i, line] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
            }
            stop = false;

            //Vérification horizontale à droite
            for (int i = column + 1; i < 7 && !stop; i++)
            {
                if (p_Board[i, line] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
            }
            stop = false;
            TokensInLine = 1;

            //Vérification verticale au dessus
            for (int i = line - 1; i >= 0 && !stop; i--)
            {
                if (p_Board[column, i] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
            }
            stop = false;

            //Vérification verticale en dessous
            for (int i = line + 1; i < 6 && !stop; i++)
            {
                if (p_Board[column, i] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
            }
            stop = false;
            TokensInLine = 1;

            //Vérification en diagonale en dessous à droite
            int j = line + 1;
            for (int i = column + 1; i < 7 && !stop && j < 6; i++)
            {
                if (p_Board[i, j] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
                j++;
            }
            stop = false;

            //Vérification en diagonale au dessus à gauche
            j = line - 1;
            for (int i = column - 1; i >= 0 && !stop && j >= 0; i--)
            {
                if (p_Board[i, j] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
                j--;
            }
            stop = false;
            TokensInLine = 1;

            //Vérification en diagonale en dessous à gauche
            j = line + 1;
            for (int i = column - 1; i >= 0 && !stop && j < 6; i--)
            {
                if (p_Board[i, j] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
                j++;
            }
            stop = false;

            //Vérification en diagonale au dessus à droite
            j = line - 1;
            for (int i = column + 1; i < 7 && !stop && j >= 0; i++)
            {
                if (p_Board[i, j] == p_Color)
                { TokensInLine++; }
                else
                { stop = true; }
                if (TokensInLine == 4)
                { return true; }
                j--;
            }
            stop = false;

            return false;
        }

        public static void clearBoard()
        {
            for (int i = 0; i < 7; i++)
            {
                for (int j = 0; j < 6; j++)
                {
                    board[i, j] = 'n';
                }
            }
        }

        public static string PrintBoard(char[,] p_Board)
        {
            string total = "";

            for (int i = 0; i < 7; i++)
            {
                string line = "";
                for (int j = 0; j < 6; j++)
                {
                    if (p_Board[i, j] == 'n')
                    {
                        line += " ";
                    }
                    else
                    {
                        if (p_Board[i, j] == 'r')
                        {
                            line += "r";
                        }
                        else
                        {
                            line += "y";
                        }
                    }
                }
                total += line + "|";
            }

            return total;
        }
    }
}
