﻿
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Connect4
{
    /// <summary>
    /// A transparent control.
    /// </summary>
    public class TransparentPanel : Panel
    {
        public bool transparent = true;

        public TransparentPanel(){}

        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams createParams = base.CreateParams;
                createParams.ExStyle |= 0x00000020; // WS_EX_TRANSPARENT
                return createParams;
            }
        }

        protected override void OnPaintBackground(PaintEventArgs e)
        {
            // Do not paint background.
        }

        protected override void OnPaint(PaintEventArgs pe)
        {
            if (!transparent)
            {
                pe.Graphics.FillRectangle(new SolidBrush(Color.FromArgb(128, 101, 135, 196)), this.ClientRectangle);
                pe.Graphics.DrawRectangle(Pens.DarkBlue,
                    pe.ClipRectangle.Left,
                    pe.ClipRectangle.Top,
                    this.Width - 1,
                    this.Height - 1);
            }
        }
    }
}